// GeradenTest.java                                 MM 2013

/**
 * Test der Klasse Gerade.
 * @author Monika Meiler
 */
public class GeradenTest
{
/**
 * Erzeugt Geraden und
 * berechnet fuer gegebene Argumente Funktionswerte.
 */
  public static void main( String[] args)
  {
// Neue Geraden (Normalfall)
    Gerade g1 = new Gerade();
    g1.setGerade( 3, 2);           // Anstieg, Absolutglied

    Gerade g2 = new Gerade();
    g2.setGerade( 3, 0, 2);               // Anstieg, Punkt

    Gerade g3 = new Gerade();
    g3.setGerade( 0, 2, 1, 5);               // zwei Punkte

// Geradenausgabe
    System.out.println( "g1( x) = " + g1);
    System.out.println( "g2( x) = " + g2);
    System.out.println( "g3( x) = " + g3);

// Neue Gerade (parall zur x-Achse)
    System.out.println();
    Gerade g4 = new Gerade();
    g4.setGerade( 0, 2);

// Geradenausgabe
    System.out.println( "g4( x) = " + g4);

// Neue Gerade (parall zur y-Achse)
    System.out.println();
    Gerade g5 = new Gerade();
    if( !g5.setGerade( 1, 2, 1, 3))
      System.out.println( "Gerade nicht definiert");

// Geradenausgabe
      System.out.println( "g5( x) = " + g5);

// Werteberechnung
    System.out.println();
    System.out.println( "Wertberechnungen");

    double y0;
    y0 = g1.wert( -2./3);
    System.out.println( "g1( " + (-2./3) + ") = " + y0);

    y0 = g1.wert( 0);
    System.out.println( "g1( " + 0. + ") = " + y0);

    y0 = g1.wert( 1);
    System.out.println( "g1( " + 1. + ") = " + y0);

    System.out.println();

    y0 = g4.wert( 1);
    System.out.println( "g4( " + 1. + ") = " + y0);

    y0 = g4.wert( 2);
    System.out.println( "g4( " + 2. + ") = " + y0);

// Wert der ersten Ableitung

    System.out.println();
    System.out.println( "Wert der ersten Ableitung");

    double y1;
    y1 = g1.wertErsteAbleitung( 0);
    System.out.println( "g1'( " + 0. + ") = " + y1);

    y1 = g1.wertErsteAbleitung( 1);
    System.out.println( "g1'( " + 1. + ") = " + y1);

// Programm beendet
    System.out.println();
    System.out.println( "Test beendet");
  }
}

/* ----------------------------------------------------- */
                                          // Testergebnisse
/*
g1( x) = 3.0x + 2.0
g2( x) = 3.0x + 2.0
g3( x) = 3.0x + 2.0

g4( x) = 0.0x + 2.0

Gerade nicht definiert
g5( x) = 0.0x + 0.0

Wertberechnungen
g1( -0.6666666666666666) = 0.0
g1( 0.0) = 2.0
g1( 1.0) = 5.0

g4( 1.0) = 2.0
g4( 2.0) = 2.0

Wert der ersten Ableitung
g1'( 0.0) = 3.0
g1'( 1.0) = 3.0
*/
