// RationaleFunktionenTest.java                     MM 2013

/**
 * Test der Klasse RationaleFunktion.
 * @author Monika Meiler
 */
public class RationaleFunktionenTest
{
/**
 * Erzeugt rationale Funktion und
 * berechnet fuer gegebene Argumente Funktionswerte.
 */
  public static void main( String[] args)
  {
// Neue Funktion (Normalfall)
    double[] zKoeff1 = { -1, 1, -1, 1};
    Polynom z1 = new Polynom();
    if( !z1.setPolynom( zKoeff1)) z1 = null;

    double[] nKoeff = { -1, -1, 1, 1};
    Polynom n1 = new Polynom();
    if( !n1.setPolynom( nKoeff)) n1 = null;

    RationaleFunktion f1 = new RationaleFunktion();
    if( f1.setRationaleFunktion( z1, n1))
      System.out.println( "f1( x) = " + f1);
    else
      System.out.println
      ( "RationaleFunktion f1(x) nicht definiert");

// Neue Funktion (Zaehler ohne Koeffizienten)
    double[] zKoeff2 = {};
    Polynom z2 = new Polynom();
    if( !z2.setPolynom( zKoeff2)) z2 = null;

    RationaleFunktion f2 = new RationaleFunktion();
    if( f2.setRationaleFunktion( z2, n1))
      System.out.println( "f2( x) = " + f2);
    else
      System.out.println
      ( "RationaleFunktion f2(x) nicht definiert");

// Neue Funktion (Zaehler Nullpointer)
    double[] zKoeff3 = null;
    Polynom z3 = new Polynom();
    if( !z3.setPolynom( zKoeff3)) z3 = null;

    RationaleFunktion f3 = new RationaleFunktion();
    if( f3.setRationaleFunktion( z3, n1))
      System.out.println( "f3( x) = " + f3);
    else
      System.out.println
      ( "RationaleFunktion f3(x) nicht definiert");


// Werteberechnung
    System.out.println();
    System.out.println( "Wertberechnungen");

    double y0 = f1.wert( -1);
    double y1 = f1.wert( 0);
    double y2 = f1.wert( 1);

// Ausgabe
    System.out.println( " f1( " + (-1.0) + ")  = " + y0);
    System.out.println( " f1( " + 0.0 + ")  = " + y1);
    System.out.println( " f1( " + 1.0 + ")  = " + y2);

// Programm beendet
    System.out.println();
    System.out.println( "Test beendet");
  }
}

/* ----------------------------------------------------- */
                                          // Testergebnisse
/*
f1( x) = ( -1.0 +  1.0 x^1 + -1.0 x^2 + 1.0 x^3 )
       / ( -1.0 + -1.0 x^1 +  1.0 x^2 + 1.0 x^3 )
RationaleFunktion f2(x) nicht definiert
RationaleFunktion f3(x) nicht definiert

Wertberechnungen
 f1( -1.0)  = -Infinity
 f1( 0.0)  = 1.0
 f1( 1.0)  = NaN
*/