// Tangens.java                                     MM 2013

/**
 * Tangensfunktion f(x) = tan( x),
 * D = R \ { x | x = PI/2 + n*PI, n aus N }, W = R.
 * @author Monika Meiler
 */
public class Tangens extends DifferenzierbareFunktion
{
/* ----------------------------------------------------- */
                                        // service-Methoden
/**
 * Berechnen eines Funktionswertes durch
 * tan( x) = sin( x)/cos( x).
 * @param arg Argument
 * @return tan( arg)
 */
  public double wert( double arg)
  {
    Sinus sin = new Sinus();
    Cosinus cos = new Cosinus();

    return sin.wert( arg) / cos.wert( arg);
  }

/**
 * Berechnen der ersten Ableitung
 * f'(x) = 1 / (cos( x) * cos( x)).
 * @param arg Argument
 * @return f'( arg)
 */
  public double wertErsteAbleitung( double arg)
  {
    Cosinus cos = new Cosinus();
    double wert = cos.wert( arg);

    return 1 / (wert * wert);
  }

/* ----------------------------------------------------- */
                                        // toString-Methode
/**
 * Darstellen der Tangensfunktion.
 * @return Funktion in linearer Schreibweise
 */
  public String toString()
  {
    return "tan( x)";
  }
}